﻿using Microsoft.Extensions.ObjectPool;
using System;
using System.Collections.Generic;
using System.Net.Sockets;

namespace ConsoleApp1
{
    internal class Program
    {
        static void Main(string[] args)
        {
            IPooledObjectPolicy<Socket> policy = new PooledObjectPolicy("localhost", 39_999);

            // maximumRetained 값을 지정하지 않으면, 기본값은 Environment.ProcessorCount * 2
            DefaultObjectPool<Socket> pool = new DefaultObjectPool<Socket>(policy, 10);

            List<Socket> sockets = new List<Socket>();
            for (int i = 0; i < 11; i++)
            {
                sockets.Add(pool.Get());
            }

            Console.WriteLine();
            sockets.ForEach((elem) => pool.Return(elem));
            sockets.Clear();

            for (int i = 0; i < 11; i++)
            {
                sockets.Add(pool.Get());
            }

            Console.WriteLine("press any key to exit...");
            Console.ReadLine();
        }
    }
}

public class PooledObjectPolicy : IPooledObjectPolicy<Socket>
{
    string _host;
    int _port;

    public PooledObjectPolicy(string host, int port)
    {
        _host = host;
        _port = port;
    }

    public Socket Create()
    {
        Socket socket = new Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp);
        socket.Connect(_host, _port);
        return socket;
    }

    public bool Return(Socket obj)
    {
        return true;
    }
}

